'this is an alpha version, i must make it faster.
'
'btw: gouraud shading in gs3d does only work with very simple objects, like
'pyramides, squares. it computes the shading of the points without anything
'about the polygons, that cannot work!! i've used some ideas from gs3d. but
'not these for shading ;)
'the loader isn't complete at the moment, it loads only the first object in
'the file, and it supports only triangels. i'm working on this :)
DECLARE SUB sort (lo%, hi%)
DECLARE SUB ReadPlgHeader (file$)
DECLARE SUB ReadPlgObject (file$)
DECLARE SUB CenterObject ()
DECLARE SUB InitGouraud ()
DECLARE SUB InitNormals ()
COMMON SHARED name$, pnt, pol
REM $DYNAMIC

SCREEN 0: CLS
PRINT "Real Lightsourced Gouraud Shading with backface culling"
PRINT ""
PRINT "Copyright: Marko Dokic 1998"
PRINT "EMail:     marko.d@gmx.net"
PRINT "Homepage:  http://www.geocities.com/SiliconValley/Network/7147/index.html"
PRINT ""
PRINT "Keys:"
PRINT "q,a  x-rotate"
PRINT "w,s  y-rotate"
PRINT "e,d  z-rotate"
PRINT "x    stop rotation"
PRINT "+,-  zoom"
PRINT ""

DEF SEG = &HA000
xs2 = 170
ys2 = 170

xs1 = 160 - xs2 / 2
xs = 160 + xs1 + xs2 / 4
xs2 = xs1 + xs2
ys1 = 100 - ys2 / 2
ys = ys1 + ys2 / 4
ys2 = ys1 + ys2
adds& = ys * 320 + xs
adda& = 319 - ((xs2 - xs1) / 2)
DIM scr(xs1 - 1 TO xs2 + 1, ys1 - 1 TO ys2 + 1) AS INTEGER

m0 = 1                           'vergrsserung vom objekt
x0 = 160                         'middle of the screen
y0 = 100                         'middle of the screen
tz = 2                           'rotate in grd
col = 63                         'number of colors

PRINT "Loading object...              ";

file$ = "teapot.plg"
ReadPlgHeader file$

PRINT name$ + "has" + STR$(pnt) + " points and" + STR$(pol) + " polygons."

DIM xb(pnt) AS INTEGER               'screen points
DIM zb(pnt) AS INTEGER               'screen points
DIM ya(pnt) AS SINGLE                'points after rotation
DIM xa(pnt) AS SINGLE                'points after rotation
DIM za(pnt) AS SINGLE                'points after rotation
DIM pc(pnt) AS SINGLE                'shade of points
DIM poc(pol) AS SINGLE               'shade of polygons
DIM SHARED yd(pnt) AS SINGLE         'original coordinates of the object
DIM SHARED xd(pnt) AS SINGLE         'original coordinates of the object
DIM SHARED zd(pnt) AS SINGLE         'original coordinates of the object
DIM SHARED ps(pnt, 20)  AS INTEGER   'stuff for gouraud shading
DIM SHARED poly(pol, 5) AS INTEGER   'polygon data
DIM SHARED norm(pol, 3) AS SINGLE    'normals of the original object

ReadPlgObject file$

CenterObject

InitGouraud

InitNormals

PRINT "Precomputing SIN-Tables"
DIM sim(450) AS SINGLE
FOR i = 0 TO 450
sim(i) = SIN(i * (3.14159265359# / 180))
NEXT i

DIM div(-10 TO 300) AS INTEGER
FOR i = -10 TO 300
IF i > 0 THEN div(i) = INT(i / 4) ELSE div(i) = 0
NEXT

min% = 1: max% = pol                                'sorting stuff
DIM SHARED iz(pol) AS SINGLE                        'sorting stuff
DIM SHARED in(pol) AS INTEGER                       'sorting stuff
DIM op AS SINGLE: DIM ppo AS SINGLE: ppo = TIMER    'framecounter stuff
DIM ly(200) AS INTEGER                              'scanline bufer
DIM cy(200) AS SINGLE                               'scanline color buffer
DIM m(10, 10) AS SINGLE                             'rotating stuff buffer

PRINT "Loading Done!"
PRINT ""
PRINT "Press a key"
DO UNTIL INKEY$ <> "": LOOP

SCREEN 13
FOR i = 0 TO col
    OUT &H3C8, i: OUT &H3C9, i: OUT &H3C9, i: OUT &H3C9, i
NEXT
COLOR 63

'main loop
DO
si1! = sim(w1): cs1! = sim(w1 + 90)
si2! = sim(w2): cs2! = sim(w2 + 90)
si3! = sim(w3): cs3! = sim(w3 + 90)

m(1, 1) = cs2! * cs3!
m(1, 2) = cs1! * si3! + si1! * si2! * cs3!
m(1, 3) = si1! * si3! - cs1! * si2! * cs3!
m(2, 1) = -cs2! * si3!
m(2, 2) = cs1! * cs3! - si1! * si2! * si3!
m(2, 3) = si1! * cs3! + cs1! * si2! * si3!
m(3, 1) = si2!
m(3, 2) = -si1! * cs2!
m(3, 3) = cs1! * cs2!

FOR i = 1 TO pnt
 xa(i) = m(1, 1) * xd(i) + m(2, 1) * yd(i) + m(3, 1) * zd(i)
 ya(i) = m(1, 2) * xd(i) + m(2, 2) * yd(i) + m(3, 2) * zd(i)
 za(i) = m(1, 3) * xd(i) + m(2, 3) * yd(i) + m(3, 3) * zd(i)
 xb(i) = x0 + xa(i)
 zb(i) = y0 + za(i)
NEXT

FOR i = 1 TO pol
 normx! = (m(1, 1) + m(1, 3)) * norm(i, 1) + (m(2, 1) + m(2, 3)) * norm(i, 2) + (m(3, 1) + m(3, 3)) * norm(i, 3)
 normy! = m(1, 2) * norm(i, 1) + m(2, 2) * norm(i, 2) + m(3, 2) * norm(i, 3)
 df! = (normx! + normy!) * col
 IF df! > col THEN df! = col
 IF df! < 0 THEN df! = 0
 poc(i) = df!
 IF normy! >= 0 THEN dp% = dp% + 1: in(dp%) = i: iz(dp%) = (ya(poly(i, 1)) + ya(poly(i, 2)) + ya(poly(i, 3))) / 3
NEXT

FOR i = 1 TO pnt
FOR t = 1 TO ps(i, 20)
sy1 = sy1 + poc(ps(i, t))
NEXT t
pc(i) = sy1 / ps(i, 20): sy1 = 0
NEXT i

sort min%, dp%

FOR i = dp% TO 1 STEP -1
j = in(i)

IF zb(poly(j, 1)) > zb(poly(j, 2)) THEN s1 = 2: s2 = 1 ELSE s1 = 1: s2 = 2
IF zb(poly(j, s2)) < zb(poly(j, 3)) THEN s2 = 3 ELSE IF zb(poly(j, s1)) > zb(poly(j, 3)) THEN s1 = 3
p1 = poly(j, s1): y1 = zb(p1): p2 = poly(j, s2): y2 = zb(p2)

IF y2 <> y1 AND y1 > ys1 AND y2 < ys2 THEN
  s3 = 6 - (s1 + s2): p3 = poly(j, s3): y3 = zb(p3)
  x1 = xb(p1): x2 = xb(p2): x3 = xb(p3): c1! = pc(p1): c2! = pc(p2): c3! = pc(p3)

  IF y3 <> y1 THEN
    xu = x3 - x1: yu = y3 - y1: x! = x1: cu! = c3! - c1!: c! = c1!
    ds! = xu / yu: cs! = cu! / yu
    FOR y = y1 TO y3
      ly(y) = INT(x!): cy(y) = c!
      x! = x! + ds!: c! = c! + cs!
    NEXT y
  END IF

  IF y2 <> y3 THEN
    xu = x2 - x3: yu = y2 - y3: x! = x3: cu! = c2! - c3!: c! = c3!
    ds! = xu / yu: cs! = cu! / yu
    FOR y = y3 TO y2
      ly(y) = INT(x!): cy(y) = c!
      x! = x! + ds!: c! = c! + cs!
    NEXT y
  END IF

  xu = x2 - x1: yu = y2 - y1: x! = x1: cu! = c2! - c1!: c! = c1!
  ds! = xu / yu: cs! = cu! / yu
  FOR y = y1 TO y2
    sx1 = ly(y): sx2 = INT(x!)
    IF sx1 <> sx2 THEN
      co1! = cy(y): co2! = c!
      IF sx1 > sx2 THEN SWAP sx1, sx2: SWAP co1!, co2!
      xu = sx2 - sx1: cu! = co2! - co1!: cl! = co1!: csl! = cu! / xu
      FOR k% = sx1 TO sx2
        scr(k%, y) = INT(cl!)
        cl! = cl! + csl!
      NEXT k%
    END IF
    x! = x! + ds!: c! = c! + cs!
  NEXT y
END IF
NEXT i

dp% = 0

FOR y = ys1 TO ys2 STEP 2
FOR x = xs1 TO xs2 STEP 2
dsm = scr(x, y) + scr(x + 1, y) + scr(x, y + 1) + scr(x + 1, y + 1)
scr(x, y) = div(dsm): scr(x + 1, y) = 0: scr(x, y + 1) = 0: scr(x + 1, y + 1) = 0
NEXT x
NEXT y

addr& = adds&
FOR y = ys1 TO ys2 STEP 2
FOR x = xs1 TO xs2 STEP 2
addr& = addr& + 1
POKE addr&, scr(x, y)
scr(x, y) = 0
NEXT x
addr& = addr& + adda&
NEXT y

op = TIMER: IF op > ppo + 1 THEN ppo = op: pt = ght: ght = 0
ght = ght + 1: LOCATE 1, 1: PRINT pt

a$ = UCASE$(INKEY$)
SELECT CASE a$
 CASE CHR$(27)
  EXIT DO
 CASE "Q"
  mx = mx + tz
 CASE "A"
  mx = mx - tz
 CASE "W"
  my = my + tz
 CASE "S"
  my = my - tz
 CASE "E"
  mz = mz + tz
 CASE "D"
  mz = mz - tz
 CASE "+"
  m1 = m0 + .2
  FOR i = 1 TO pnt: xd(i) = (xd(i) / m0) * m1: yd(i) = (yd(i) / m0) * m1: zd(i) = (zd(i) / m0) * m1: NEXT
  m0 = m1
 CASE "-"
  m1 = m0 - .2
  FOR i = 1 TO pnt: xd(i) = (xd(i) / m0) * m1: yd(i) = (yd(i) / m0) * m1: zd(i) = (zd(i) / m0) * m1: NEXT
  m0 = m1
 CASE "C"
  CLS
 CASE "X"
  mx = 0: my = 0: mz = 0
END SELECT

w1 = w1 + mx
w2 = w2 + my
w3 = w3 + mz
w1 = w1 MOD 360: IF w1 < 0 THEN w1 = 360 + w1
w2 = w2 MOD 360: IF w2 < 0 THEN w2 = 360 + w2
w3 = w3 MOD 360: IF w3 < 0 THEN w3 = 360 + w3
LOOP

END

REM $STATIC
SUB CenterObject
maxx! = xd(1)
minx! = xd(1)
maxy! = yd(1)
miny! = yd(1)
maxz! = zd(1)
minz! = zd(1)

PRINT "centering and normaling the object..."
FOR i = 1 TO pnt
IF maxx! < xd(i) THEN maxx! = xd(i)
IF minx! > xd(i) THEN minx! = xd(i)
IF maxy! < yd(i) THEN maxy! = yd(i)
IF miny! > yd(i) THEN miny! = yd(i)
IF maxz! < zd(i) THEN maxz! = zd(i)
IF minz! > zd(i) THEN minz! = zd(i)
NEXT
normx! = (maxx! + minx!) / 2
normy! = (maxy! + miny!) / 2
normz! = (maxz! + minz!) / 2
IF maxx! > maxy! THEN s1! = maxx! ELSE s1! = maxy!
IF s1! < maxz! THEN s1! = maxz!
IF s1! <> 0 THEN s2! = 30 / s1! ELSE s2! = 1
FOR i = 1 TO pnt
xd(i) = (xd(i) - normx!) * s2!
yd(i) = (yd(i) - normy!) * s2!
zd(i) = (zd(i) - normz!) * s2!
NEXT
END SUB

SUB InitGouraud
PRINT "Precomputing some stuff for gouraud shading... "
dp! = 100 / pnt: df! = 0: LOCATE 16, 55: PRINT "% done"
FOR i = 1 TO pnt
p1 = 1
df! = df! + dp!: LOCATE 16, 50: PRINT INT(df!)
FOR t = 1 TO pol
IF p1 > 19 THEN EXIT FOR
IF poly(t, 1) = i OR poly(t, 2) = i OR poly(t, 3) = i THEN ps(i, p1) = t: p1 = p1 + 1
NEXT t
ps(i, 20) = p1
NEXT i
'end of loading polygon data
END SUB

SUB InitNormals
PRINT "computing normals..."
FOR i = 1 TO pol
 norm(i, 2) = ((zd(poly(i, 1)) - zd(poly(i, 2))) * (xd(poly(i, 2)) - xd(poly(i, 3)))) - ((xd(poly(i, 1)) - xd(poly(i, 2))) * (zd(poly(i, 2)) - zd(poly(i, 3))))
 norm(i, 3) = ((xd(poly(i, 1)) - xd(poly(i, 2))) * (yd(poly(i, 2)) - yd(poly(i, 3)))) - ((yd(poly(i, 1)) - yd(poly(i, 2))) * (xd(poly(i, 2)) - xd(poly(i, 3))))
 norm(i, 1) = ((yd(poly(i, 1)) - yd(poly(i, 2))) * (zd(poly(i, 2)) - zd(poly(i, 3)))) - ((zd(poly(i, 1)) - zd(poly(i, 2))) * (yd(poly(i, 2)) - yd(poly(i, 3))))
 nor! = SQR(norm(i, 1) ^ 2 + norm(i, 2) ^ 2 + norm(i, 3) ^ 2)
 IF nor! <> 0 THEN norm(i, 1) = norm(i, 1) / nor!: norm(i, 2) = norm(i, 2) / nor!: norm(i, 3) = norm(i, 3) / nor!
NEXT
END SUB

SUB ReadPlgHeader (file$)
OPEN file$ FOR INPUT AS 1
LINE INPUT #1, lbuf$
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
name$ = LEFT$(lbuf$, lps)
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
pnt = VAL(LEFT$(lbuf$, lps))
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
pol = VAL(LEFT$(lbuf$, lps))
CLOSE
END SUB

SUB ReadPlgObject (file$)
OPEN file$ FOR INPUT AS 1
LINE INPUT #1, lbuf$
FOR i = 1 TO pnt
LINE INPUT #1, lbuf$
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
xd(i) = VAL(LEFT$(lbuf$, lps))
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
yd(i) = VAL(LEFT$(lbuf$, lps))
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
zd(i) = VAL(lbuf$)
'PRINT xd(i), yd(i), zd(i)
NEXT i
'read polygons
FOR i = 1 TO pol
LINE INPUT #1, lbuf$
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
nop = VAL(LEFT$(lbuf$, lps))
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
nop = VAL(LEFT$(lbuf$, lps))
IF nop = 4 THEN PRINT "at the moment this programm only supports triangles. it want look right!"
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
poly(i, 1) = VAL(LEFT$(lbuf$, lps)) + 1
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
poly(i, 2) = VAL(LEFT$(lbuf$, lps)) + 1
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$)
lps = INSTR(lbuf$, " ")
poly(i, 3) = VAL(lbuf$) + 1
'PRINT poly(i, 1), poly(i, 2), poly(i, 3)
NEXT i
CLOSE
'end of loading data
END SUB

SUB sort (lo%, hi%)
  i% = lo%: j% = hi%: mid = iz(INT((hi% + lo%) / 2))
  DO UNTIL i% > j%
    DO WHILE iz(i%) < mid: i% = i% + 1: LOOP
    DO WHILE mid < iz(j%): j% = j% - 1: LOOP
    IF i% <= j% THEN SWAP in(i%), in(j%): SWAP iz(i%), iz(j%): i% = i% + 1: j% = j% - 1
  LOOP
  IF lo% < j% THEN sort lo%, j%
  IF i% < hi% THEN sort i%, hi%
END SUB

